/*
   SNU 4190.310 HW4
   by hgkang @ kaist
*/
  
%{
exception Parser_Implementation_Error
open Dplus

type dec = Var of string * exp
         | Fun of string * string * exp
fun extract_let_sugar([],body) = raise Parser_Implementation_Error
  | extract_let_sugar((Var(id,exp)::[]),body) = 
      LETV(id,exp,body) 
  | extract_let_sugar(Var(id,exp)::tl,body) = 
      LETV(id,exp,extract_let_sugar(tl,body))  
  | extract_let_sugar((Fun(f,x,exp)::[]),body) = 
      LETF(f,x,exp,body) 
  | extract_let_sugar(Fun(f,x,exp)::tl,body) = 
      LETF(f,x,exp,extract_let_sugar(tl,body))  
%} 

%token TRUE FALSE NOT EQUAL PLUS MINUS STAR SLASH COLONEQ SEMICOLON LET IN VAR
%token IF THEN ELSE END WHILE DO FOR TO READ WRITE PROC CALL NIL
%token LP RP LB RB LBRACE RBRACE DOT COMMA EOF
%token <int> NUM
%token <string> ID
%left SEMICOLON
%nonassoc THEN
%nonassoc ELSE
%right COLONEQ
%right WRITE         
%left EQUAL LB  
%left PLUS MINUS
%left STAR SLASH
%left DOT
%right NOT

%start program
%type <Dplus.exp> program
%%
program: expr EOF   {$1}
       ;
expr: LP RP {UNIT}
    | LP expr RP {$2}
    | NUM {NUM($1)}
    | ID {VAR($1)}
    | TRUE {TRUE}
    | FALSE {FALSE}
    | NOT expr {NOT($2)}
    | expr PLUS expr {ADD($1,$3)}
    | expr MINUS expr {SUB($1,$3)}
    | expr STAR expr {MUL($1,$3)}
    | expr SLASH expr {DIV($1,$3)}
    | expr EQUAL expr {EQUAL($1,$3)}
    | expr LB expr {LESS($1,$3)}
    | ID COLONEQ expr {ASSIGN($1,$3)}
    | expr SEMICOLON expr {SEQ($1,$3)}
    | IF expr THEN expr ELSE expr {IFTE($2,$4,$6)}
    | IF expr THEN expr {IFT($2,$4)}
    | WHILE expr DO expr END {WHILE($2,$4)}
    | READ ID {READ ($2)}
    | READ LP ID RP {READ ($3)}
    | WRITE expr {WRITE ($2)}
    | CALL ID LP expr RP  {CALLV($2,$4)}
    | LET decls IN expr END {extract_let_sugar($2,$4)}
    | LBRACE RBRACE {RECORD []}
    | LBRACE fields RBRACE {RECORD $2}
    | expr DOT ID COLONEQ expr {ASSIGNF ($1, $3, $5)}
    | expr DOT ID {FIELD ($1, $3)}
    ;  

fields: ID COLONEQ expr {[($1, $3)]}
    | ID COLONEQ expr COMMA fields {($1,$3)::$5}
    ;

decls:
    | decl                 { [$1] }
    | decl decls           { $1::$2 }
decl: VAR ID COLONEQ expr  { Var($2,$4)}
    | PROC ID LP ID RP EQUAL expr {Fun($2,$4,$7)}

    ;
%%
